<?php

namespace WPDRMS\ASP\API\REST0;
use ASP_Query, WP_REST_Request;

if ( !class_exists(__NAMESPACE__ . '\RouteWooSearch') ) {
	class RouteWooSearch implements RouteInterface {
		function handle( WP_REST_Request $request): array {
			$defaults = $args = array(
				's' => '',
				'id' => -1
			);
			foreach ($defaults as $k => $v) {
				$param = $request->get_param($k);
				if ( $param !== null ) {
					$args[$k] = $param;
				}
			}

			if ( $args['id'] == -1 ) {
				// Fetch the search ID, which is probably the WooCommerce search
				foreach (wd_asp()->instances->get() as $instance) {
					if ( in_array('product', $instance['data']['customtypes']) ) {
						$args['id'] = $instance['id'];
						break;
					}
				}
			}

			// No search was found with products enabled, set it explicitly
			if ( $args['id'] == -1 ) {
				$args['post_type'] = array('product');
			}

			$args = apply_filters('asp_rest_woo_search_query_args', $args, $args['id'], $request);

			$asp_query = new ASP_Query($args, $args['id']);

			return $asp_query->posts;
		}
	}
}